////////////////////////////////////////////////////////////////////////////
// benchmark1 for SIMLIB/C++
// simple benchmark - dependency on local data size
//

#include "simlib.h"

const long N = 1000000;
const double Tend = N+2;
long size=10; // default

class Test1 : public Process {
  void Behavior() {
    volatile char data[size];
    data[0] = 1;
    for(int i=0; i<N; i++)
        Wait(1);
    if(data[0] != 1)
        _Print("Error\n");
  }
};

int main(int argc, char *argv[]) {
//  Print("Basic test of process switching effectivity\n");
  if(argc>1) {
      size = 0;
      size = std::strtoul(argv[1],0,10);
      if(size<1)
          _Print("Error: bad local data size\n");
  }
  Print("size=%ld n=%ld\n",size,N);
  Init(0, Tend);              // 
  (new Test1)->Activate();    // create process, activate
  Run();                      
  return 0;
}

