////////////////////////////////////////////////////////////////////////////
// benchmark2          SIMLIB/C++
// simple benchmark --- N processes

#include "simlib.h"

double Tend = 10;
long N=10;

class Bench2 : public Process {
  void Behavior() {
    char data[] = { 1 };
    data[0] = 1;
    Wait(1);
    if(data[0] != 1)
        _Print("Error1\n");
    Wait(1);
    if(data[0] != 1)
        _Print("Error2\n");
    Wait(1);
    if(data[0] != 1)
        _Print("Error3\n");
    Wait(1);
    if(data[0] != 1)
        _Print("Error4\n");
    Wait(1);
    if(data[0] != 1)
        _Print("Error5\n");
  }
};

int main(int argc, char *argv[])
{
    //DebugON();
    if (argc > 1) {
        N = 0;
        N = std::strtoul(argv[1], 0, 10);
        if (N < 1)
            _Print("Error: bad argument\n");
    }
    Print("N=%ld\n", N);
    int i = 0;
    try {
        Init(0, Tend);          // Initialize time
        // create and activate N processes
        for (i = 0; i < N; i++)
            (new Bench2)->Activate();
        Run();                  // simulation
    }
    catch(std::bad_alloc) {
        Print("No memory after %d created processes\n", i);
    }
}
