////////////////////////////////////////////////////////////////////////////
// Model CTEST2.CPP               SIMLIB/C++
//
// filter: 
//
//      F(p) = 1 / (p^3 + 3.25p^2 + 16.5p + 17.5)
//
// compute step response
//

#include "simlib.h"

#define OUTPUT_FILE "ctest.dat"

const double StepPrn  = 0.05;

struct CircleTest {
  Integrator x, y;
  CircleTest() : // connections
    x(-y,1),   // x' = -y,  x(0) = 1
    y(x) {}    // y' = x,   y(0) = 0
};

CircleTest t;

void Sample() {
  Print("%9.3f %f %f \n", T.Value(), t.x.Value(), t.y.Value());
}
Sampler S(Sample, StepPrn);

int main(int argc, char *argv[]) { // experiment
  char *m = "rke";
  if(argc>1) m = argv[1];
  SetOutput(OUTPUT_FILE);
  Print("# Time x y\n");
  Init(0,1000);
  SetStep(1e-3);
  SetMethod(m);
  Print("#Method %s\n", m);
  Run();
}

